(function(global, factory) {
  typeof exports === "object" && typeof module !== "undefined" ? factory(exports, require("child_process")) : typeof define === "function" && define.amd ? define(["exports", "child_process"], factory) : (global = typeof globalThis !== "undefined" ? globalThis : global || self, factory(global["node-utils"] = {}, global.child_process));
})(this, function(exports2, child_process) {
  "use strict";
  function $(str, ...args) {
    let cmd = str.reduce((acc, part, i) => acc + part + (args[i] || ""), "");
    return new Promise((res, rej) => child_process.exec(cmd, (err, stdout, stderr) => {
      if (err || stderr) return rej(err || stderr);
      return res(stdout);
    }));
  }
  function $Sync(str, ...args) {
    let cmd = str.reduce((acc, part, i) => acc + part + (args[i] || ""), "");
    return child_process.execSync(cmd, { encoding: "utf-8" });
  }
  const readline = {};
  function ask(prompt, hide = false) {
    const rl = readline.createInterface({ input: process.stdin, output: process.stdout, terminal: true });
    return new Promise((resolve) => {
      if (!hide) {
        rl.question(prompt, (answer) => {
          resolve(answer);
          rl.close();
        });
      } else {
        let input = "";
        const onKeyPress = (char, key) => {
          if (key && key.name === "return") {
            rl.input.setRawMode(false);
            rl.input.removeListener("keypress", onKeyPress);
            rl.close();
            resolve(input);
          } else {
            if (key && key.name === "backspace") {
              if (input.length > 0) input = input.slice(0, -1);
            } else {
              input += char;
            }
            rl.output.write(`\r${prompt}${"*".repeat(input.length)} `);
          }
        };
        rl.input.on("keypress", onKeyPress);
        rl.input.setRawMode(true);
        rl.input.resume();
        rl.output.write(prompt);
      }
    });
  }
  exports2.$ = $;
  exports2.$Sync = $Sync;
  exports2.ask = ask;
  Object.defineProperty(exports2, Symbol.toStringTag, { value: "Module" });
});
//# sourceMappingURL=index.cjs.map
