import { exec, execSync } from "child_process";
function $(str, ...args) {
  let cmd = str.reduce((acc, part, i) => acc + part + (args[i] || ""), "");
  return new Promise((res, rej) => exec(cmd, (err, stdout, stderr) => {
    if (err || stderr) return rej(err || stderr);
    return res(stdout);
  }));
}
function $Sync(str, ...args) {
  let cmd = str.reduce((acc, part, i) => acc + part + (args[i] || ""), "");
  return execSync(cmd, { encoding: "utf-8" });
}
const readline = {};
function ask(prompt, hide = false) {
  const rl = readline.createInterface({ input: process.stdin, output: process.stdout, terminal: true });
  return new Promise((resolve) => {
    if (!hide) {
      rl.question(prompt, (answer) => {
        resolve(answer);
        rl.close();
      });
    } else {
      let input = "";
      const onKeyPress = (char, key) => {
        if (key && key.name === "return") {
          rl.input.setRawMode(false);
          rl.input.removeListener("keypress", onKeyPress);
          rl.close();
          resolve(input);
        } else {
          if (key && key.name === "backspace") {
            if (input.length > 0) input = input.slice(0, -1);
          } else {
            input += char;
          }
          rl.output.write(`\r${prompt}${"*".repeat(input.length)} `);
        }
      };
      rl.input.on("keypress", onKeyPress);
      rl.input.setRawMode(true);
      rl.input.resume();
      rl.output.write(prompt);
    }
  });
}
export {
  $,
  $Sync,
  ask
};
//# sourceMappingURL=index.mjs.map
